/*
 *  Copyright (C) 2003 Hiroyuki Ikezoe
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

typedef struct _RSS RSS;
typedef struct _RSSItem RSSItem;

struct _RSS
{
	/* widget */
	GtkWidget *MenuItem;
	GtkWidget *SubMenu;
	
	gchar *title;
	/* uri of rss/rdf  */
	gchar *uri;
	/* local file name */
	gchar *localfile;

	/* rss file item */
	gchar *rss_title;
	gchar *rss_link;
	gchar *rss_description;
	gchar *rss_date;
	
	/* rss items */
	GSList *items;
	
	/* update timer id */
	guint timer_id;
	/* update interval minutes */
	gint  update_interval;
};

struct _RSSItem
{
	gchar *title;
	gchar *link;
	gchar *description;
	gchar *date;
};

void rss_menu_update(RSS *rss);
void rss_update(RSS *rss);
